<script>
  // Dimensions
  const width = 800;
  const height = 100;
  const margin = { top: 10, right: 20, bottom: 20, left: 20 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  const radius = 10

  // Arrays
  const points = [
    innerWidth / 2 - 60,
    innerWidth / 2 - 30,
    innerWidth / 2,
    innerWidth / 2 + 30,
    innerWidth / 2 + 60
  ];

  // All lights with a higher index are on!
  $: index = points.length;

  // Color
  $: color = "darkred";

  let mi = 0

  function countDown() {
    index -= 1
    // if all lights are red (index ==0) => randomize time to get to green (between 1 and 4 seconds)
    if (index == 0) { 
      clearInterval(mi)
      mi = setInterval(countDown, 1000 + Math.random()*3000)
    }
    // after the lights got green => stop the countDown
    if (index < 0) {
      clearInterval(mi)
      color = "green"
    }

  }
  function startRace(g) {
    mi = setInterval(countDown, 1000)  
  }
</script>

<svg viewBox="0 0 {width} {height}">
  <g transform="translate({margin.left},{margin.top})" use:startRace>
    {#each points as point, i}
      <circle cx="{point}" cy="{innerHeight/2}" r="{radius}" fill="{color}" fill-opacity="{i >= index ? 1 : 0.3}"/>
    {/each}
   </g>
</svg>
